//Charly DUMUR
//Nicolas BOUTIN
//Le 31/01/07

//************ Prototypes Fonctions ************//

int DetcectNL(void);
unsigned char Recupheure(void);
unsigned char DebutDCF(void);
void RecupTrameDCF(void);
void RecupMinDCF(void);

//************ Fonctions  ************//
void RecupMinDCF(void)
{
	unsigned char MinDCF=0; // Variable permettant de stocker les minutes rcupres par le DCF
	
	MinDCF=TabDCF[21] + TabDCF[22]*2 + TabDCF[23]*4 + TabDCF[24]*8 + TabDCF[25]*10 + TabDCF[26]*20 + TabDCF[27]*40; // Rcupration des minutes  partir du tableau contenant la trame DCF(en prenant en compte le poids des bits)
	LCDGotoXY(0,0);
	LCDPutInt(MinDCF); // Afficher les minutes
}

void RecupTrameDCF(void)
{
	unsigned char i=0;

	if(DebutDCF()==1)	CptTabDCF=0;// Si il y a eu un dbut de trame DCF, remettre l'indice du tableau  zro.
	if(CptTabDCF==59)				// Si le tableau contenant la trame DCF est plein...
	{
		LCDGotoXY(1,0);			  // Aller  la colonne 1 ligne 0 
		for(i=0;i<60;i++)		  // ...pour chaque bit de la trame DCF...
		{
			LCDPutInt(TabDCF[i]);// ...afficher le niveau logique du bit
		}
	}
}

unsigned char DetectNL(void)
{
	
//	CptDCF=0;				// Mise  zro du compteur pour pouvoir compter 150 ms
	
	while(CptDCF!=15); 		// Attendre les 150 ms
	
	if(Dcf)					//Si niveau logique 1
	{
		return 1;			// Renvoyer 1
	}
	else return 0;			// Sinon renvoyer 0
	
}

unsigned char DebutDCF(void)
{
	
	if (DebDCF==98)  // Si il n'y eu aucun front montant pendant 980 ms ...
	{
		DebDCF=0;    // RAZ de la variable servant  dtecter le dbut de trame
//		SW3=!SW3;	 // Utilisation de la led SW3 lors du dbogage
		return 1;	 // Signaler le dbut de trame
		
	}
	else return 0;	 // Sinon signaler qu'il n'y a pas de dbut de trame

}

