//Charly DUMUR
//Nicolas BOUTIN
//Le 31/01/07

#include "I2Clib.h"
//************* Prototypes Fonctions ********************//

void Horloge(void);
void RegHorloge(void);

//************ Fonctions  ************//

void RegHorloge(void)
{
	static unsigned char um=0;
	static unsigned char dm=0;	
	static unsigned char uh=0;
	static unsigned char dh=0;

	LCDClear();
	LCDGotoXY(0,0);
	LCDPutText("Reglage de l'heure..");
	LCDGotoXY(4,1);
	LCDPutText("00h00");
	LCDGotoXY(4,2);
	LCDPutChar('^');
	LCDGotoXY(0,3);
	LCDPutText("Appui=Valider");
	Delay10KTCYx(400);				//Pause pour curseur
	while(PORTAbits.RA2!=0)	
	{		
		LCDCursor(0);				//Eteint curseur
		PosHOld=PosH;				//Mise a jour position curseur horizontal
	
		if(JoyX()==1)				//Si joystick se dplace vers la droite	
		{
			PosH++;
			Delay10KTCYx(400);		//Pause pour curseur
		}

			if(JoyX()==-1)			//Si le joystick se dplace vers la gauche
		{
			PosH--;
			Delay10KTCYx(400);		//Pause pour curseur
		}

		if((JoyY()==-1))			//Si joystick se deplace vers le bas
		{
		
			switch(PosH)			//suivant position horizontal du curseur
			{
				case 4 : 	dh++;				//Incrementer les dizaines d'heure
							if(dh>2) dh=0;
							LCDGotoXY(PosH,1);
							LCDPutInt(dh);
							break;
							
				case 5 : 	uh++;				//Incrementer les unites d'heure
							if(uh>9) uh=0;
							if((uh>3) && (dh==2)) uh=0;
							LCDGotoXY(PosH,1);
							LCDPutInt(uh);
							break;

				case 7 :	 dm++;				//Incrementer les dizaines de minutes
							if(dm>5) dm=0;
							LCDGotoXY(PosH,1);
							LCDPutInt(dm);
							break;

				case 8 :	 um++;				//Incrementer les units de minutes
							if(um>9) um=0;
							LCDGotoXY(PosH,1);
							LCDPutInt(um);
							break;
			}
			Delay10KTCYx(500);					//Pause pour curseur
		}
		if((JoyY()==1))							//Si joystick se deplace vers le haut
		{
			
			switch(PosH)						//Suivant la position du curseur horizontal
			{
				case 4 : 	dh--;				//Decrementer les dizaines d'heure
							if(dh>10) dh=2;		//Borne
							LCDGotoXY(PosH,1);
							LCDPutInt(dh);
							break;
							
				case 5 : 	uh--;				//Decrementer les unites d'heure
							if(uh>10) uh=9;		//Borne
							if((uh>0) && (dh==2)) uh=0;
							LCDGotoXY(PosH,1);
							LCDPutInt(uh);
							break;

				case 7 :	dm--;				//Decrementer les dizaines de minutes
							if(dm>10) dm=5;		//Borne
							LCDGotoXY(PosH,1);
							LCDPutInt(dm);
							break;

				case 8 :	um--;				//Decrementer les units de minutes
							if(um>10) um=9;		//Borne
							LCDGotoXY(PosH,1);
							LCDPutInt(um);
							break;
			}
			Delay10KTCYx(500);					//Pause pour curseur
		}

		if	(PosH<4) PosH=8;					//Borne gauche du curseur pour l'affichage
		if	(PosH>8) PosH=4;					//Borne droite du curseur pour l'affichage
		if 	((PosH==6) && (PosHOld==5))	PosH=7;	//Borne pour sauter le 'h' afficher
		if 	((PosH==6) && (PosHOld==7))	PosH=5;	//Borne pour sauter le 'h' afficher
		
		if(PosH!=PosHOld)						//si position du curseur horizontal diffrente d l'ancienne
		{
			//Affichage du curseur
			LCDGotoXY(PosH,2);
			LCDPutChar('^');
			LCDGotoXY(PosHOld,2);
			LCDPutChar(' ');
		}
	
		
	}	
	LCDClear();									//Effacer ecran
	//Affichage de la confirmation que l'heure est bien reglee
	LCDGotoXY(4,1);
	LCDPutText("Heure reglee");
	LCDGotoXY(0,3);
	LCDPutText("Gauche=Retour");
	//Mise a jour des variables globale pour l'heure
	umin=um;
	dmin=dm;
	uheure=uh;
	dheure=dh;

}

void Horloge(void)
{
	while(JoyX()!=-1)					//Tant que non demande de retour par le joystick 
	{
		//Afficher 'HORLOGE'
		LCDGotoXY(4,1);
		LCDPutText("HORLOGE");		
		LCDGotoXY(0,3);
		LCDPutText("Gauche=Retour");	
		//Affichage sur l'ecran geant de l'heure
		SendI2C(0x4E,Af[dheure]);//Aff1
		SendI2C(0x4A,Af[uheure]);//Aff2
		SendI2C(0x46,Af[dmin]);//Aff3
		SendI2C(0x4C,Af[umin]);//Aff4
	}
	//Affichage neutre sur l'ecran geant
	SendI2C(0x4E,0x40);
	SendI2C(0x4A,0x40);
	SendI2C(0x46,0x40);
	SendI2C(0x4C,0x40);
}
