//Charly DUMUR
//Nicolas BOUTIN
//Le 31/01/07
//Ce programme permet de grer l'horloge destine au chronomtrage
//des courses de robots suiveurs de ligne.

//************ Variable Globale ************//

unsigned char centisec=0;	//Variable globale pour les centimes de secondes
unsigned char dixisec=0;	//Variable globale pour les diximes de secondes
unsigned char usec=0;		//Variable globale pour les units de secondes
unsigned char dsec=0;		//Variable globale pour les dizaines de secondes
unsigned char umin=0;		//____________________________units de minutes
unsigned char dmin=0;		//____________________________dizaines de minutes
unsigned char uheure=0;		//____________________________units d'heures
unsigned char dheure=0;		//___________________________ dizaines d'heures


unsigned char cdixisec=0;	//Variable globale pour les diximes de secondes (CHRONO)
unsigned char ccentisec=0;	//Variable globale pour les centimes de secondes (CHRONO)

//Tableau de conversion des chiffres en valeur Hxadcimal pour les afficheurs
static unsigned char Af[10]={0x3f,0x06,0x6d,0x4f,0x56,0x5b,0x7b,0x0e,0x7f,0x5f};
//							  0	   1	2	 3    4    5	6	 7    8	   9

unsigned char PosMenu=0;	//Variable pour connaitre ds quel menu l'on est.

unsigned char PosV=1;		//Variable pour Menu selon axe Y
unsigned char PosVOld=1;	//Variable Ancienne pour Menu selon axe Y

unsigned char PosH=4;		//Variable pour le reglage manuel de l'heure
unsigned char PosHOld=4;	//Variable ancinne pr le reglage manuel de l'heure

unsigned char CptDCF=0;		//Variable globale pour dtection NL sur la trame DCF
unsigned char DCFNL=0;		//Variable de rcupration du NL du signal DCF
unsigned char DebDCF=0;		//Varaible pour la dtection du dbut de trame DCF
int TabDCF[59];				//Tableau de rcupration de la trame DCF
int CptTabDCF=0;			//Variable pour rcuperer la trame DCF

//************************** Fichier d'Entete **********************************/

#define 	SW1			PORTBbits.RB4		//Led SW1 pour test
#define 	SW2			PORTBbits.RB3		//Led SW2 pour test
#define 	SW3			PORTBbits.RB2		//Led SW3 pour test
#define		Dcf	 		PORTBbits.RB1		//Signal du module DCF
#define		J1D			PORTBbits.RB0		//Dclenchement chrono par BIR pour le Joueur 1 Depart
#define		J1A			PORTDbits.RD7 		//Dclenchement chrono par BIR pour le Joueur 1 Arrive


#include <delays.h>			//Temporisation
#include <p18f452.h>		//Port entre sortie et registre
#include <timers.h>     	//Librairie pour le timer

#include  "I2Clib.h"			//Librairie pour l'I2C
#include "lcd.h"				//Librairie pour l'afficheur lcd
#include "FctDCF.h"				//Code de la fonction dcodage de la trame DCF77
#include "FctInterupt.h"		//Code de la fonction interruption
#include "FctES.h"				//Code de dclarations des entres sorties



#include "joystick.h"		//Code pour utiliser le joystick			
#include "FctChrono.h"		//Code de la fonction chronomtre
#include "FctHorloge.h"		//Code de la fonction horloge
#include "FctMenu.h"		//Code pour les menus de l'afficheur


//************ Instruction de configuration du pic et de l'horloge *************/

#pragma config WDT = OFF	// Pas de chien de garde
#pragma config OSC = HS		// Quartz HS(High Speed) pour un quartz 20MHz

 //************PROGRAMME PRINCIPAL************//	

void main(void)
{	
	SW1=0;							 
	SW2=0;							// Extinction des leds SW1,SW2 et SW3
	SW3=0;
	InitEntrSort();					// Initialisation des entres sorties
	InitInterrupt();				// Initialisation des interruptions
	InitI2C();						// Initialisation de l'IC	
	LCDClear();						// Effacement de l'cran LCD

	InitJoystick();					// Initialisation du joystick
	ZeroJoystick();					// Calibrage du joystick
	MenuPrinc();					// Affichage du menu principal sur l'cran LCD
	while(1)						// Faire indfiniment....
	{
			MouvtVerti();			//...la gestion du joystick dans le menu sur le plan vertical		
			MouvtHoriz();			//...la gestion du joystick dans le menu sur le plan horizontal
		
	}
}
