//Charly DUMUR
//Nicolas BOUTIN
//Le 31/01/07

//************ Prototypes Fonctions ************//

void MenuPrinc(void);
void MenuHorloge(void);
void MenuChrono(void);
void MenuDCF(void);
void MouvtVerti(void);
void MouvtHoriz(void);

//************ Fonctions  ************//

void MouvtHoriz(void)
{
//-----	DANS LE MENU PRINCIPAL	-----//
	if(JoyX()==1 && (PosMenu==0))			//Si le joystick se dplace vers la gauche et position dans le menu principal
	{
		LCDClear();							//Effacer l'cran
		switch(PosV)						//Suivant la position Verticale du curseur
		{
			case 1 : MenuHorloge();break;	//Saut vers le menu horloge
			case 2 : MenuChrono();break;	//Saut vers le menu chrono
			case 3 : MenuDCF();break;		//Saut vers le menu DCF
			default: break;
		}
		Delay10KTCYx(500);					//Pause pour affichage
	}
//-----	DANS LE MENU HORLOGE	-----//
	if(JoyX()==1 && (PosMenu==1))			//Si Joystick se deplace vers la gauche et position ds le menu Horloge
	{
		LCDClear();							//Effacer l'ecran
		switch(PosV)						//Suivant la position Verticale du curseur
		{
			case 1 : 	/*Afficher l'heure*/
						PosMenu=11;			//Actualise la position dans les menus
						Horloge();
						break;
			
			case 2 : 	/*Reglage manuel*/
						PosMenu=12;			//Actualise la position dans les menus
						RegHorloge();
						break;

			default: 	MenuPrinc();		//Retour vers le menu principal
						break;
		}
	}

//-----	DANS LE MENU CHRONOMETRE	-----//
	if(JoyX()==1 && (PosMenu==2))			//Si Joystick se deplace vers la gauche et position ds le menu Chrono
	{
		LCDClear();							//Effacer l'ecran
		switch(PosV)						//Suivant la position Verticale du curseur
		{
			case 1 : 	/*Reset Chrono*/
						PosMenu=21;			//Actualise la position dans les menus
						ResetChrono();		//Saut vers la fonction ResetChrono
						break;
			
			case 2 : 	/*Dtection BIR*/
						PosMenu=22;			//Actualise la position dans les menus
						ChronoBIR();		//Saut vers la fonction dclenchement du chrono par barrire infra rouge
						break;
			
			case 3 :	/*Chrono Manuel*/
						PosMenu=23;			//Actualise la position dans les menus
						Chrono();			//Saut vers la fonction chrono
						break;

			default: 	MenuPrinc();		//Retour vers le menu principal
						break;
		}
	}
//-----	DANS LE MENU SYNCHRODCF	-----//
	if(JoyX()==1 && (PosMenu==3))			//Si Joystick se deplace vers la gauche et position ds le menu Chrono
	{
		LCDClear();							//Effacer l'ecran
		switch(PosV)						//Suivant la position Verticale du curseur
		{
			case 1 : 	/*Synchroniser*/	//(Fonction non ralise)
						PosMenu=31;			//Actualise la position dans les menus						
						if(JoyX()==-1)		//Si joystick vers la gauche 
							MenuDCF();		//Saut vers le menu DCF
						break;

			default: 	MenuPrinc();		//Retour vers le menu principal
						break;
		}
	}
//-----	Retour Menu Principal	-----//
	if((JoyX()==-1) && ((PosMenu==1) || (PosMenu==2) || (PosMenu==3)))	//Si joystick vers la gauche et position dans sous menu niveau 1
	{
		LCDClear();							//Effacer ecran
		MenuPrinc();						//Saut vers le menu principal
	}

//-----	Retour Menu Horloge	-----//
	if((JoyX()==-1) && ((PosMenu==11) || (PosMenu==12)))				//Si joystick vers la gauche et position dans sous menu horloge
	{
		LCDClear();							//Effacer ecran
		MenuHorloge();						//Saut vers le menu horloge
		Delay10KTCYx(500);					//Pause pour affichage
	}

//-----	Retour Menu Chronometre	-----//
	if((JoyX()==-1) && ((PosMenu==21) || (PosMenu==22)	|| (PosMenu==23)))//Si joystick vers la gauche et position dans sous menu chronometre
	{
		LCDClear();							//Effacer ecran
		MenuChrono();						//Saut vers le menu chronometre
		Delay10KTCYx(500);					//Pause pour affichage
	}

//-----	Retour Menu SynchroDCF	-----//
	if((JoyX()==-1) && (PosMenu==31))		//Si joystick vers la gauche et position dans sous menu DCF
	{
		LCDClear();							//Effacer ecran
		MenuDCF();							//Saut vers le menu DCF
		Delay10KTCYx(500);					//Pause pour affichage
	}
}

void MouvtVerti(void)
{
	PosVOld=PosV;							//Mise a jour de la position du curseur
		
	if(JoyY()==-1 )							//Si joystick se deplace vers le bas
	{
		PosV++;
	}
	if(JoyY()==1)							//Si le joystick se deplace vers le haut
	{
		PosV--;
	}

	//Permet de delimiter la zone d'affichage du curseur sur le LCD
	if(PosV<1) PosV=1;						//Borne haute du curseur
	if(PosV>3) PosV=3;						//Borne basse du curseur


	if(PosV!=PosVOld)						//Si ancienne position differnte de la position actuelle
	{
		//Permet l'affichage du curseur
		LCDGotoXY(0,PosV);			
		LCDPutChar('-');
		LCDGotoXY(1,PosV);
		LCDPutChar('>');
		LCDGotoXY(0,(PosVOld));				
		LCDPutChar(' ');
		LCDGotoXY(1,(PosVOld));
		LCDPutChar(' ');
		Delay10KTCYx(500);					//Pause pour affichage du curseurcurseur
	}
}

void MenuDCF(void)
{
	LCDCursor(0);							//Eteindre le curseur
	PosMenu=3;								//Position dans le menu
	PosV=1;									//Rinitialise la position du curseur vertical
	//Affichage du menu DCF
	LCDGotoXY(0,0);							
	LCDPutText("Menu Synchro DCF");
	LCDGotoXY(0,1);
	LCDPutText("->Synchroniser");
	//Affichage neutre sur l'ecran geant
	SendI2C(0x4E,0x40);//Aff1
	SendI2C(0x4A,0x40);//Aff2
	SendI2C(0x46,0x40);//Aff3
	SendI2C(0x4C,0x40);//Aff4

}
void MenuChrono(void)
{
	LCDCursor(0);							//Eteindre le curseur
	PosMenu=2;								//Position dans le menu
	PosV=1;									//Rinitialise la position du curseur vertical
	//Affichage du menu chrono
	LCDGotoXY(0,0);
	LCDPutText("Menu Chronometre");
	LCDGotoXY(0,1);
	LCDPutText("->Reset");
	LCDGotoXY(0,2);
	LCDPutText("  Lancer (Bar. IR)");
	LCDGotoXY(0,3);
	LCDPutText("  Chrono Manuel");
	//Affichage neutre sur l'ecran geant
	SendI2C(0x4E,0x40);//Aff1
	SendI2C(0x4A,0x40);//Aff2
	SendI2C(0x46,0x40);//Aff3
	SendI2C(0x4C,0x40);//Aff4
}

void MenuHorloge(void)
{
	LCDCursor(0);							//Eteindre le curseur
	PosMenu=1;								//Position dans le menu
	PosV=1;									//Rinitialise la position du curseur vertical
	//Affichage du menu horloge
	LCDGotoXY(0,0);
	LCDPutText("Menu Horloge");
	LCDGotoXY(0,1);
	LCDPutText("->Afficher l'heure");
	LCDGotoXY(0,2);
	LCDPutText("  Reglage manuel");
	//Affichage neutre sur l'ecran geant
	SendI2C(0x4E,0x40);//Aff1
	SendI2C(0x4A,0x40);//Aff2
	SendI2C(0x46,0x40);//Aff3
	SendI2C(0x4C,0x40);//Aff4
}

void MenuPrinc (void)
{
	LCDCursor(0);							//Eteindre le curseur
	PosMenu=0;								//Position dans le menu
	PosV=1;									//Rinitialise la position du curseur vertical
	//Affichage du menu principal
	LCDGotoXY(0,0);
	LCDPutText("Menu Principal");
	LCDGotoXY(0,1);
	LCDPutText("->Horloge");
	LCDGotoXY(0,2);
	LCDPutText("  Chronometre");
	LCDGotoXY(0,3);
	LCDPutText("  Synchro DCF");
	//Affichage neutre sur l'ecran geant
	SendI2C(0x4E,0x40);//Aff1
	SendI2C(0x4A,0x40);//Aff2
	SendI2C(0x46,0x40);//Aff3
	SendI2C(0x4C,0x40);//Aff4
}

